function cg = channelgain_CR_uplink(R, R_p, U, alpha,varianza)

Gtx = 16;       
Grx = 6;        
mu = 0;        
sigma = 10;     

[x,y] = PU_CU_cell_gen(R, R_p, U);

[distance_path_loss_dB, distUser] = propagation_model_CR_uplink(x, y,R_p,alpha);

shadowing_dB = randn(U).*sigma + mu;

h = abs(1 / sqrt(2) * (randn(U) + j * randn(U)));

PathLoss = distance_path_loss_dB + shadowing_dB + 20.*log10(h) - Gtx - Grx;

tamano=size(PathLoss)

if tamano(1)==tamano(2)
    
    ruidoaditivo=(varianza).*randn(tamano(1));
    
    for i=1:tamano(1)
        for h=1:tamano(2)
            ruidoaditivo(i,h)
            if(ruidoaditivo(i,h)<0)
                ruidaditivo(i,h)=-10*log10(abs(ruidoaditivo(i,h)))
            else
                ruidaditivo(i,h)=10*log10(ruidoaditivo(i,h))
            end
        end
    end        
    
else
   error('Something is not working :(')
end


PathLoss=PathLoss+ruidoaditivo;

cg = 10.^(-PathLoss / 10);
