% function [M, MM] = number_variation(SNR_avrage_dB, therm_noise_mW)

if 0
R = [0.1 .2 .3 0.5 ]; %worst case requested rate in bits/sec/Hz

SNRdb = 10;
SNR = 10.*(SNRdb/10);
sigma = .5;

therm_noise_mW = 4.0039e-012;
sigma_mW = therm_noise_mW;
sigma_W = sigma_mW * 1e-3;
G = 4.5386e-010;
maxBTStxPower_mW = 1000;
Pmax = 1;%Watt
SNR_avrage_mW = G * maxBTStxPower_mW / therm_noise_mW;
SNR_avrage_dBm = 10 * log10(SNR_avrage_mW);
SNR_avrage_dB = SNR_avrage_dBm - 30;
SNR = 10^(SNR_avrage_dB/10);

q = 0.05;
R = 0.1;
const = -log(1-q)/(2^R-1);
M1 = const * SNR * sigma_W - 1/SNR
M2 = const /(G*Pmax) - sigma_W / (G*Pmax)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SNR = 10;
q = 0:0.01:0.1;
R = [0.1 .2 .3 0.5 ]; %worst case requested rate in bits/sec/Hz
G = 0.25;
for uu = 1:length(R)
    for ii = 1:length(q)
        q(ii);
        R(uu);
        %N(uu,ii) = -log(1-q(ii))/(Pmax*G*R(uu))
        %M(uu,ii) = -log(1-q)*SNR*sigma/(2^R(uu)-1)) - 1/SNR;
        M(uu,ii) = -log(1-q(ii))/(2^R(uu)-1)/G - 1/SNR;
    end
end
%%%%%%%%%%%%%%%%%%%%%How to save in a file%%%%%%%%%%%%%%%%%%%%%%%%
% L = length(M);
% prefixe_out = 'E:\Desktop\Geir\matlab';
% 
% signal = [prefixe_out 'M'];
% fid = fopen(signal, 'w');
% fwrite(fid, M, 'float32');
% fclose(fid);
% 
% signal_1 = [prefixe_out 'M'];
% fid_1 = fopen([signal_1]);
% M = fread(fid_1, L, 'float32');
% fclose(fid_1); 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
plot(q,M)
xlabel({'-----outage probability----->';'<------QoS------'})
ylabel('Upper bound on the number of allowed secondary users ')
legend('R = 0.1','R = 0.2','R = 0.3','R = 1')%,'R = 0.5',...
%'R = 0.6','R = 0.7','R = 0.8','R = 0.9','R = 1')
ylim([0 8])
grid on
title(['SNR = ' num2str(SNR) ]);%, ';    P_{max} = ' num2str(Pmax)])
M
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%clear all
R = [0.1 .2 .3 0.5 ];
q = 0.05; 
SNRdb = -10:30;
SNR = 10.*(SNRdb/10);
G = 0.25;
clear MM

for uu = 1:length(R)
    for jj = 1:length(SNR)
        SNR(jj)
                MM(uu,jj) = -log(1-q)/(2^R(uu)-1)/G - 1/SNR(jj)
        %MM(uu,jj) = -log(1-q)*SNR(jj)*sigma/(2^R(uu)-1) - 1/SNR(jj);
    end
end
MM

% figure(1)
% plot(SNRdb, MM)
% xlabel('SNR in dB')
% ylabel('Upper bound on the number of secondary users M ')
% %xlim([6 12])
% legend('R = 0.1','R = 0.3','R = 0.5','R = 0.7')%,'R = 0.5',...
% %'R = 0.6','R = 0.7','R = 0.8','R = 0.9','R = 1')
% grid on
% title('q = 0.2; G = 0.25; \sigma^2 = 0.25 ')



figure(2)
plot(SNRdb, MM)
xlabel('SNR ')
ylabel('Upper bound on the number of allowed secondary users ')
xlim([0 30])
ylim([0 10])
legend('R = 0.1','R = 0.2','R = 0.3','R = 0.5')%,'R = 0.5',...
%'R = 0.6','R = 0.7','R = 0.8','R = 0.9','R = 1')
grid on
title(['q = ' num2str(q)])% 
%    ' G = ' num2str(G) , ';    \sigma^2 = ' num2str(sigma)])

% figure(1)
% plot(Pmax_db, MM)
% xlabel('Pmax in dB')
% ylabel('Upper bound on the number of secondary users M ')
% %xlim([0 5])
% legend('R = 0.1','R = 0.3','R = 0.5','R = 0.7')%,'R = 0.5',...
% %'R = 0.6','R = 0.7','R = 0.8','R = 0.9','R = 1')
% grid on
% title(['q = ' num2str(q) ,';   G = ' int2str(G) , ';    \sigma^2 = ' num2str(sigma)])

% q = 0.1;
% for uu = 1:length(R)
%     for jj = 1:length(SNR)
%         MM(uu,jj) = -log(1-q)/(Pmax*G*(2^R(uu)-1)) - (sigma(jj)/Pmax/G);
%     end
% end


% figure
% plot(SNRdb, MM)
% xlabel('SNR in dB')
% ylabel('Number of cognitive users M')
% ylim([0 10])
% legend('R = 0.1','R = 0.2','R = 0.3','R = 1')%,'R = 0.5',...
% %'R = 0.6','R = 0.7','R = 0.8','R = 0.9','R = 1')
% grid on
% title('R in bits/sec/Hz')


R = [0.1 .2 .3 0.5 ];
q = 0.05; 
SNR = 10;
G = [1e-3:1e-3:0.1 0.1:0.1:1];

clear MM

for uu = 1:length(R)
    for jj = 1:length(G)
        G(jj);
                MM(uu,jj) = -log(1-q)/(2^R(uu)-1)/G(jj) - 1/SNR
        %MM(uu,jj) = -log(1-q)*SNR(jj)*sigma/(2^R(uu)-1) - 1/SNR(jj);
    end
end


figure(3)
plot(G, MM)
xlabel('G ')
ylabel('Upper bound on the number of allowed secondary users ')
% xlim([0 30])
ylim([0 10])
legend('R = 0.1','R = 0.2','R = 0.3','R = 0.5')%,'R = 0.5',...
%'R = 0.6','R = 0.7','R = 0.8','R = 0.9','R = 1')
grid on
title(['q = ' num2str(q)])% 