function cg = channelgain_CR_downlink(R, R_p, U, alpha,varianza)

% R = 1000;       % Outer radius of primary cell in meters
% R_p = 600;      % interference protection radius of primary cell in meters
% U = 8;          % number of users (PU + SUs)
% alpha = 50;     %in meters
Gtx = 16;       % Tx antenna gain in dB
Grx = 6;        % Rx antenna gain in dB
mu = 0;         % Mean for lognormal shadowing
sigma = 10;     % S.D. for lognromal shadowing
%varianza=1e-2;

[x,y] = PU_CU_cell_gen(R, R_p, U);

[distance_path_loss_dB, distUser] = propagation_model_CR_downlink(x, y,R_p,alpha);

shadowing_dB = randn(U).*sigma + mu;

h = abs(1 / sqrt(2) * (randn(U) + j * randn(U)));

PathLoss = distance_path_loss_dB + shadowing_dB + 20.*log10(h) - Gtx - Grx

%cg = 10.^(-PathLoss / 10);

%PARA EL MODELO DE ERROR ADITIVO

%sumamos la cantidad en dB simplemente

tamano=size(PathLoss);

if tamano(1)==tamano(2)
    
    ruidoaditivo=sqrt(varianza).*randn(tamano(1));
    
    for i=1:tamano(1)
        for h=1:tamano(2)
            
            if(ruidoaditivo(i,h)<0)
                ruidaditivo(i,h)=-10*log10(abs(ruidoaditivo(i,h)));
            else
                ruidaditivo(i,h)=10*log10(ruidoaditivo(i,h));
            end
        end
    end        
    
else
    
    error('Something is not working :(')
end


PathLoss=PathLoss+ruidoaditivo;

cg = 10.^(-PathLoss / 10)
    
    
